<?php

namespace Drupal\ckeditor_bootstrap_table_tools\Plugin\CKEditorPlugin;

use Drupal\ckeditor\CKEditorPluginBase;
use Drupal\ckeditor\CKEditorPluginConfigurableInterface;
use Drupal\ckeditor\CKEditorPluginContextualInterface;
use Drupal\Core\Form\FormStateInterface;
use Drupal\editor\Entity\Editor;

/**
 * Defines the "CKEditor Bootstrap Table Tools" plugin.
 *
 * @CKEditorPlugin(
 *   id = "jsplus_bootstrap_table_tools",
 *   label = @Translation("CKEditor Bootstrap Table Tools"),
 *   module = "ckeditor_bootstrap_table_tools"
 * )
 */
class ckeditor_bootstrap_table_tools extends CKEditorPluginBase implements CKEditorPluginConfigurableInterface, CKEditorPluginContextualInterface {

  public $plugins = array(
     'jsplus_bootstrap_table_new' => array(
        'buttons' => array(array('label' => 'Create new Bootstrap table')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/new-bootstrap-table-plugin',
        'params' => array(
            array(
                'name' => 'jsplus_bootstrap_table_new_default_add_header',
                'default' => FALSE,
                'type' => 'bool',
                'order' => 2010,
                'title' => 'New table: add header subtag',
                'hint' => '',
                'widget' => 'checkbox'
            ),
            array(
                'name' => 'jsplus_bootstrap_table_new_default_striped',
                'default' => TRUE,
                'type' => 'bool',
                'order' => 2020,
                'title' => 'New table: create striped table',
                'hint' => '',
                'widget' => 'checkbox'
            ),
            array(
                'name' => 'jsplus_bootstrap_table_new_default_bordered',
                'default' => FALSE,
                'type' => 'bool',
                'order' => 2030,
                'title' => 'New table: create bordered table',
                'hint' => '',
                'widget' => 'checkbox'
            ),
            array(
                'name' => 'jsplus_bootstrap_table_new_default_condensed',
                'default' => FALSE,
                'type' => 'bool',
                'order' => 2040,
                'title' => 'Create condenced table',
                'hint' => '',
                'widget' => 'checkbox'
            ),
            array(
                'name' => 'jsplus_bootstrap_table_new_class',
                'default' => '',
                'type' => 'str',
                'order' => 2050,
                'title' => 'New table: classes for table',
                'hint' => 'Separated with space',
                'widget' => 'text'
            ),
            array(
                'name' => 'jsplus_bootstrap_table_new_style',
                'default' => '',
                'type' => 'str',
                'order' => 2060,
                'title' => 'New table: styles for table',
                'hint' => 'Syntax like in "style" attribute',
                'widget' => 'text'
            ),
        )
     ),
     'jsplus_bootstrap_table_conf' => array(
        'buttons' => array(array('label' => 'Configure Bootstrap table')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/bootstrap-table-configuration-plugin',
     ),
     'jsplus_bootstrap_table_row_conf' => array(
        'buttons' => array(array('label' => 'Configure Bootstrap table row')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/bootstrap-table-row-configuration-plugin',
     ),
     'jsplus_bootstrap_table_col_conf' => array(
        'buttons' => array(array('label' => 'Configure Bootstrap table column')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/insert-bootstrap-table-column-plugin',
     ),
     'jsplus_bootstrap_table_cell_conf' => array(
        'buttons' => array(array('label' => 'Configure Bootstrap table cell')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/bootstrap-table-cell-configuration-plugin',
     ),
     'jsplus_bootstrap_table_row_move_up' => array(
        'buttons' => array(array('label' => 'Move table row up')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/move-bootstrap-table-row',
     ),
     'jsplus_bootstrap_table_row_move_down' => array(
        'buttons' => array(array('label' => 'Move table row down')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/move-bootstrap-table-row',
     ),
     'jsplus_bootstrap_table_col_move_left' => array(
        'buttons' => array(array('label' => 'Move table column left')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/move-bootstrap-table-column-plugin',
     ),
     'jsplus_bootstrap_table_col_move_right' => array(
        'buttons' => array(array('label' => 'Move table column right')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/move-bootstrap-table-column-plugin',
     ),
     'jsplus_bootstrap_table_add_row_up' => array(
        'buttons' => array(array('label' => 'Add table row above')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/insert-bootstrap-table-row-plugin',
     ),
     'jsplus_bootstrap_table_add_row_down' => array(
        'buttons' => array(array('label' => 'Add table row below')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/insert-bootstrap-table-row-plugin',
     ),
     'jsplus_bootstrap_table_add_col_left' => array(
        'buttons' => array(array('label' => 'Add table column left')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/insert-bootstrap-table-column-plugin',
     ),
     'jsplus_bootstrap_table_add_col_right' => array(
        'buttons' => array(array('label' => 'Add table column right')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/insert-bootstrap-table-column-plugin',
     ),
     'jsplus_bootstrap_table_add_cell_left' => array(
        'buttons' => array(array('label' => 'Add cell left')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/insert-bootstrap-table-cell-plugin',
     ),
     'jsplus_bootstrap_table_add_cell_right' => array(
        'buttons' => array(array('label' => 'Add cell right')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/insert-bootstrap-table-cell-plugin',
     ),
     'jsplus_bootstrap_table_delete_col' => array(
        'buttons' => array(array('label' => 'Delete table column')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/delete-bootstrap-table-column-plugin',
     ),
     'jsplus_bootstrap_table_delete_row' => array(
        'buttons' => array(array('label' => 'Delete table row')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/delete-bootstrap-table-row-plugin',
     ),
     'jsplus_bootstrap_table_delete_cell' => array(
        'buttons' => array(array('label' => 'Delete table cell')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/delete-bootstrap-table-cell-plugin',
     ),
     'jsplus_bootstrap_table_merge_cells' => array(
        'buttons' => array(array('label' => 'Merge table cells')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/merge-bootstrap-table-cells-plugin',
     ),
     'jsplus_bootstrap_table_merge_cell_right' => array(
        'buttons' => array(array('label' => 'Merge cell right')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/merge-bootstrap-table-cells-plugin',
     ),
     'jsplus_bootstrap_table_merge_cell_down' => array(
        'buttons' => array(array('label' => 'Merge cell down')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/merge-bootstrap-table-cells-plugin',
     ),
     'jsplus_bootstrap_table_split_cell_hor' => array(
        'buttons' => array(array('label' => 'Split cell horizontally')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/split-bootstrap-table-cell-plugin',
     ),
     'jsplus_bootstrap_table_split_cell_vert' => array(
        'buttons' => array(array('label' => 'Split cell vertically')),
        'urlDoc' => 'http://js.plus/products/bootstrap-table-tools/split-bootstrap-table-cell-plugin',
     ),
  );

    /**
     * {@inheritdoc}
     */
    public function getButtons() {
        if (!$this->isInstalled())
            return array();

        $buttons = array();
        foreach ($this->plugins as $pluginName => $pluginDef) {

            if (isset($pluginDef['buttons'])) {
                foreach($pluginDef['buttons'] as $buttonName => $buttonDef) {
                    $image = '/icons/' . $pluginName . '.png';
                    if (isset($buttonDef['image']))
                        $image = $pluginDef['image'];
                    $button = array(
                        'label' => $buttonDef['label'],
                        'image' => '/libraries/jsplus_bootstrap_table_tools' . $image
                    );
                    $buttons[$pluginName] = $button;
                }
            }

        }
        return $buttons;
    }

  /**
   * {@inheritdoc}
   */
  public function getFile() {
    return '/libraries/jsplus_bootstrap_table_tools/plugin.js';
  }

  /**
   * {@inheritdoc}
   */
  public function getDependencies(Editor $editor) {
    return array();
  }

  /**
   * {@inheritdoc}
   */
  public function getLibraries(Editor $editor) {
    return array();
  }

  /**
   * {@inheritdoc}
   */
  public function isInternal() {
    return FALSE;
  }

  /**
   * {@inheritdoc}
   */
  public function isEnabled(Editor $editor) {
    return TRUE;
  }

  function getConfigParam($settings, $param, $default, $type, $inside) {
    $name = $param;
    if ($inside != null)
        $name = $inside . '.' . $name;
    if (isset($settings[$name]) && strlen($settings[$name]) > 0)
        $value = $settings[$name];
    else
        $value = $default;
    if (isset($type) && $type == 'int') {
        $value = intval($value);
    } else if (isset($type) && $type == 'bool') {
        if ($value == '1')
            $value = true;
        else if ($value == '0')
            $value = false;
    } else if (isset($type) && $type == 'json') {
        $value = json_decode($value);
    }
    return $value;
  }

  /**
   * {@inheritdoc}
   */
  public function getConfig(Editor $editor) {
    $settings = $editor->getSettings()['plugins']['jsplus_bootstrap_table_tools'];
    $result = array();
    foreach ($this->plugins as $pluginName => $pluginDef) {
        if (isset($pluginDef['params'])) {
            foreach ($pluginDef['params'] as $paramDef) {
                $value = $this->getConfigParam($settings, $paramDef['name'], $paramDef['default'], $paramDef['type'], isset($paramDef['inside']) ? $paramDef['inside'] : null);
                $key = null;
                if (!isset($pluginDef['inside']))
                    $key = $paramDef['name'];
                else {
                    if (!isset($result[$paramDef['inside']]))
                        $result[$paramDef['inside']] = array();
                    $key = $paramDef['inside'][$paramDef['name']];
                }
                $result[$key] = $value;
            }
        }
    }

    return $result;
  }

  function addSelectToForm(& $form, $settings, $param, $title, $default, $options, $inside, $urlHelp) {
      $form[$param] = array(
        '#type' => 'select',
        '#title' => $title,
        '#options' => $options,
        '#default_value' => $this->getConfigParam($settings, $param, $default, 'str', $inside),
        '#attributes' => array('data-url-help' => $urlHelp == '' ? '' : ($urlHelp . '#' . $param), 'data-param-name' => $param)
      );
  }

  function addTextboxToForm(& $form, $settings, $param, $title, $default, $desc, $inside, $urlHelp) {
        $form[$param] = array(
          '#type' => 'textfield',
          '#title' => $title,
          '#default_value' => $this->getConfigParam($settings, $param, $default, 'str', $inside),
          '#description' => $desc,
          '#attributes' => array('data-url-help' => $urlHelp == '' ? '' : ($urlHelp . '#' . $param), 'data-param-name' => $param)
        );
  }

  function addTextareaToForm(& $form, $settings, $param, $title, $default, $desc, $inside, $urlHelp) {
        $form[$param] = array(
          '#type' => 'textarea',
          '#title' => $title,
          '#default_value' => $this->getConfigParam($settings, $param, $default, 'str', $inside),
          '#description' => $desc,
          '#attributes' => array('data-url-help' => $urlHelp == '' ? '' : ($urlHelp . '#' . $param), 'data-param-name' => $param)
        );
  }

  function addCheckboxToForm(& $form, $settings, $param, $title, $default, $desc, $inside, $urlHelp) {
        $form[$param] = array(
          '#type' => 'checkbox',
          '#title' => $title,
          '#default_value' => $this->getConfigParam($settings, $param, $default, 'bool', $inside),
          '#description' => $desc,
          '#attributes' => array('data-url-help' => $urlHelp == '' ? '' : ($urlHelp . '#' . $param), 'data-param-name' => $param)
        );
  }

  public function isInstalled() {
    return file_exists($_SERVER['DOCUMENT_ROOT'] . '/libraries/jsplus_bootstrap_table_tools');
  }

  /**
   * {@inheritdoc}
   */
  public function settingsForm(array $form, FormStateInterface $form_state, Editor $editor) {
    $editor_settings = $editor->getSettings();
    if (isset($editor_settings['plugins']['jsplus_bootstrap_table_tools'])) {
      $settings = $editor_settings['plugins']['jsplus_bootstrap_table_tools'];
    }

    $form['#attached']['library'][] = 'ckeditor_bootstrap_table_tools/ckeditor_bootstrap_table_tools.admin';

    if (!$this->isInstalled()) {
        $form['warning'] = array(
            '#markup' => 'Looks like CKEditor Bootstrap Table Tools (Drupal 8 module) is installed but CKEditor add-ons not found. In order to use this module please copy CKEditor add-ons into "libraries" forder in the root of your Drupal 8 installation (create the directory if it does not exist).'
        );
        return $form;
    }

    $params = array();
    foreach ($this->plugins as $pluginName => $pluginDef) {
        if (isset($pluginDef['params']))
            foreach ($pluginDef['params'] as $paramDef) {
                $paramDef['urlDoc'] = $pluginDef['urlDoc'];
                $params[$paramDef['order']] = $paramDef;
            }
    }
    ksort($params); // sort by key (order)

    foreach ($params as $order => $paramDef) {
        $inside = isset($paramDef['inside']) ? $paramDef['inside'] : null;
        if ($paramDef['widget'] == 'select') {
            $this->addSelectToForm($form, $settings, $paramDef['name'], t($paramDef['title']), $paramDef['default'], $paramDef['widgetOptions'], $inside, $paramDef['urlDoc']);
        } else if ($paramDef['widget'] == 'checkbox') {
            $this->addCheckboxToForm($form, $settings, $paramDef['name'], t($paramDef['title']), $paramDef['default'], $paramDef['hint'], $inside, $paramDef['urlDoc']);
        } else if ($paramDef['widget'] == 'textarea') {
            $this->addTextareaToForm($form, $settings, $paramDef['name'], t($paramDef['title']), $paramDef['default'], $paramDef['hint'], $inside, $paramDef['urlDoc']);
        } else {
            $this->addTextboxToForm($form, $settings, $paramDef['name'], t($paramDef['title']), $paramDef['default'], $paramDef['hint'], $inside, $paramDef['urlDoc']);
        }
    }

    return $form;
  }

}
